// This File is written/copyright 2004, Mirko Roller

#include<math.h>
#include "/usr/include/SDL/SDL.h"

#define RGB(x,y,z)     ( (x) << 10 | (y) << 5 | (z) << 0 )

static SDL_Surface *video;

static int xoff=320/2, yoff=240/2;
static double angle = 0.0;

extern int cosibus[];

static unsigned short colors[256];
static int stars [6300][3];
static int starsr[6300][3];
static int old   [6300][3];


void putpixel16(SDL_Surface *dst, Uint16 x, Uint16 y, Uint32 pixel) {
        if ( (x<320) && (y<240) )
        *((Uint16 *)dst->pixels + y * dst->pitch/2 + x) = pixel;}

void Transform(int *ta, int *tb) {
        double y = 0.0, z = 0.0;
        y = (cos((angle / 20)) * *ta) - (sin((angle / 20)) * *tb);
        z = (sin((angle / 20)) * *ta) + (cos((angle / 20)) * *tb);
        *ta = (int) floor(y);
        *tb = (int) floor(z);
}

void InitStars(void) {
        int i=0,j;
        for (i = 0; i < 800; i++) {
          stars[i][0] = ((rand() % 640/2)+1 -320/2); // x
          stars[i][1] = ((rand() % 640/2)+1 -320/2); // y
          stars[i++][2] = ((rand() % 640/2)+1 -320/2); // z 
          }

          for (j=-160;j<160;j++){
          stars[i][0]   =    j;
          stars[i][1]   = -160;
          stars[i++][2] = -160; }
          for (j=-160;j<160;j++){
          stars[i][0]   = -160;
          stars[i][1]   =    j;
          stars[i++][2] = -160; }
          for (j=-160;j<160;j++){
          stars[i][0]   = -160;
          stars[i][1]   = -160;
          stars[i++][2] =    j; }

          for (j=-160;j<160;j++){
          stars[i][0]   =   j;
          stars[i][1]   = 160;
          stars[i++][2] = 160; }
          for (j=-160;j<160;j++){
          stars[i][0]   = 160;
          stars[i][1]   =   j;
          stars[i++][2] = 160; }
          for (j=-160;j<160;j++){
          stars[i][0]   = 160;
          stars[i][1]   = 160;
          stars[i++][2] =   j; }

          for (j=-160;j<160;j++){
          stars[i][0]   =   j;
          stars[i][1]   = -160;
          stars[i++][2] = 160; }
          for (j=-160;j<160;j++){
          stars[i][0]   = -160;
          stars[i][1]   =   j;
          stars[i++][2] = 160; }
          for (j=-160;j<160;j++){
          stars[i][0]   = -160;
          stars[i][1]   = 160;
          stars[i++][2] =   j; }

          for (j=-160;j<160;j++){
          stars[i][0]   =   j;
          stars[i][1]   = 160;
          stars[i++][2] = -160; }
          for (j=-160;j<160;j++){
          stars[i][0]   = 160;
          stars[i][1]   =   j;
          stars[i++][2] = -160; }
          for (j=-160;j<160;j++){
          stars[i][0]   = 160;
          stars[i][1]   = -160;
          stars[i++][2] =   j; }



          for (i=0;i<256;i++) colors[i]=RGB(i/8,i/8,i/8);
}

int main(int argc, char *argv[]) {

        int i;
        int x, y, oldx, oldy;
        unsigned char color ;

        SDL_Init(SDL_INIT_VIDEO) ;
        video = SDL_SetVideoMode(320, 240, 15, 0);


        InitStars();
        do {
                for (i = 0; i < 6300; i++) {
                        old[i][0] = starsr[i][0];
                        old[i][1] = starsr[i][1];
                        old[i][2] = starsr[i][2];
        
                        starsr[i][0] = stars[i][0];
                        starsr[i][1] = stars[i][1];
                        starsr[i][2] = stars[i][2];
        
                        Transform(&starsr[i][1], &starsr[i][2]);
                        Transform(&starsr[i][0], &starsr[i][2]);
                        //Transform(&starsr[i][0], &starsr[i][1]);


                        oldx = (int) floor(((256*2*old[i][0])/(old[i][2]-1024))+xoff);
                        oldy = (int) floor(((256*2*old[i][1])/(old[i][2]-1024))+yoff);

                        x = (int) floor(((256*2*starsr[i][0])/(starsr[i][2]-1024))+xoff);
                        y = (int) floor(((256*2*starsr[i][1])/(starsr[i][2]-1024))+yoff);
                
                        color = (starsr[i][2]+640)/4;
                        //printf ("%d,",color);
                        putpixel16(video,oldx,oldy,0x0000);
                        putpixel16(video,   x,   y,colors[color]);
                }

                SDL_UpdateRect(video, 0, 0, 0, 0);
                angle += 0.1; 
        usleep(2000);
        } while(1);

}



