// this file is written/copyright by Mirko Roller

#include <math.h>
#include <gp32.h>
#include "sbox.h"

unsigned short *framebuffer;
unsigned char   angle [320*240];
unsigned char profond [320*240];
extern unsigned char tunneldata2[];
extern unsigned char modfile[];
extern const unsigned short texture[];

void refresh () {
  static double turn=0;
  unsigned char depX=0,depY=0;
  unsigned char *a =angle;
  unsigned char *p =profond;
  unsigned char x,y;
  unsigned short *tmp = (unsigned short *)framebuffer;
  int i,j;

  depX = 120 * ( 1 + sin ( turn ) );
  depY = 120 * ( 1 + cos ( turn ) );
  turn += 3.1415/100;
  //if (turn > 3.1415 ) turn =0;

  for ( j=0 ; j<320 ; j++ )
    for ( i=0 ; i<240 ; i++ ) {
        x = (( *(a++) + depX ) % 256) >> 1;
        y = (( *(p++) + depY ) % 256) >> 1;
        * (tmp++) = *( texture + (y<<7) + x );
    }
}

void tunnel () {
  unsigned short *buf;
  unsigned short i,j;
  unsigned int b=0;
  unsigned char *a=angle;
  unsigned char *p=profond;

  // Init vorgerechnet
  for ( j=0 ; j<320 ; j++ )
  for ( i=0 ; i<240 ; i++ ) {
    *a++ = tunneldata2[b++];
    *p++ = tunneldata2[b++];
  }
}

void clockselect() {
    int select;
    SELECTBOX sbox;
     
    sbox.x = 50;
    sbox.y =  8;
    sbox.bannercolor = 0xF800>>5;
    strcpy (sbox.banner,"MR.MIRKO CLOCKSPEEDTESTER");
    sbox.textcolor = 0xF800>>5;   // Green
    sbox.boxcolor  = 0xF800>>10;  // Blue
    strcpy (sbox.text[0],"133");
    strcpy (sbox.text[1],"160");
    strcpy (sbox.text[2],"164");   
    strcpy (sbox.text[3],"166");
    strcpy (sbox.text[4],"168");
    strcpy (sbox.text[5],"172");
    strcpy (sbox.text[6],"176");
    strcpy (sbox.text[7],"180");
    strcpy (sbox.text[8],"184");
    strcpy (sbox.text[9],"188");
    strcpy (sbox.text[10],"192");
    strcpy (sbox.text[11],"196");
    strcpy (sbox.text[12],"200");
    strcpy (sbox.text[13],"204");
    strcpy (sbox.text[14],"208");
    strcpy (sbox.text[15],"212");
    strcpy (sbox.text[16],"216");
    strcpy (sbox.text[17],"220");
    strcpy (sbox.text[18],"224");
    strcpy (sbox.text[19],"228");
    strcpy (sbox.text[20],"232");
    strcpy (sbox.text[21],"236");
    strcpy (sbox.text[22],"240");
    strcpy (sbox.text[23],"244");
    strcpy (sbox.text[24],"248");
    strcpy (sbox.text[25],"252");
    strcpy (sbox.text[26],"256");
    
    
    sbox.entrys = 27;
    select=gp_drawSelectbox ( &sbox,FRAMEBUFFER );
    
    if (select == 0)  gp_setCpuspeed(133);
    if (select == 1)  gp_setCpuspeed(160);
    if (select == 2)  gp_setCpuspeed(164);
    if (select == 3)  gp_setCpuspeed(166);
    if (select == 4)  gp_setCpuspeed(168);
    if (select == 5)  gp_setCpuspeed(172);
    if (select == 6)  gp_setCpuspeed(176);
    if (select == 7)  gp_setCpuspeed(180);
    if (select == 8)  gp_setCpuspeed(184);
    if (select == 9)  gp_setCpuspeed(188);
    if (select == 10) gp_setCpuspeed(192);
    if (select == 11) gp_setCpuspeed(196);
    if (select == 12) gp_setCpuspeed(200);
    if (select == 13) gp_setCpuspeed(204);
    if (select == 14) gp_setCpuspeed(208);
    if (select == 15) gp_setCpuspeed(212);
    if (select == 16) gp_setCpuspeed(216);
    if (select == 17) gp_setCpuspeed(220);
    if (select == 18) gp_setCpuspeed(224);
    if (select == 19) gp_setCpuspeed(228);
    if (select == 20) gp_setCpuspeed(232);
    if (select == 21) gp_setCpuspeed(236);
    if (select == 22) gp_setCpuspeed(240);
    if (select == 23) gp_setCpuspeed(244);
    if (select == 24) gp_setCpuspeed(248);
    if (select == 25) gp_setCpuspeed(252);
    if (select == 26) gp_setCpuspeed(256);
}

int main (int argc, char *argv[]) {

   framebuffer = (u16*) FRAMEBUFFER;
   int fps=0;char sbuffer[16];int timer;
   
   gp_setCpuspeed(33);
   gp_initFramebuffer(framebuffer,16,85);
   gp_clearFramebuffer16(framebuffer,0xFFFF);
   
   clockselect();
   gp_initFramebuffer(framebuffer,16,85);
   gp_initRTC();
   
   tunnel();   // Init tunnel
   while (1) {
   
      refresh();
      fps++;
      timer=gp_getRTC(); if (timer>63) { sprintf(sbuffer,"%d ",fps);fps=0;gp_clearRTC();timer=0;}
      gp_drawString (300,5,2,sbuffer,0xf800>>5,framebuffer);
      if ( gp_getButton() & BUTTON_START  ) { gp_startSoundmixer(1);gp_startModfile(modfile); }
      if ( gp_getButton() & BUTTON_SELECT )   gp_pauseModfile();
      if ( gp_getButton() & BUTTON_B )        gp_resumeModfile();
      if ( gp_getButton() & BUTTON_R )        gp_Reset();
   }
   
}

