// This file is written by Mirko Roller

#include "gp32.h"

// 0                   20                  40                            70
// Hello World!        0123456789          abcdefghijklmnopqrstuvwxqz    ABCDEFGHIJKLMNOPQRSTUVWXYZ
// 100 bytes length


GPFILE *smc_fopen(const char *path, const char *mode);
 

int main() {
        
  u16  *framebuffer;
  char buffer[255];
  char text[128];
  int  err;
  GPFILE *gpfile;
  
  framebuffer=(u16*) FRAMEBUFFER;
  gp_setCpuspeed(33);
  gp_initFramebuffer(framebuffer,16,85);

    // GPFILE *smc_fopen(const char *path, const char *mode)
    // size_t smc_fread(void *ptr, size_t size, size_t nmemb, GPFILE *stream)
    // int smc_fclose(GPFILE *stream)
    // int smc_fseek(GPFILE *stream, long offset, int whence)
    //   SEEK_SET
    //   SEEK_END
    //   SEEK_CUR
    // long smc_ftell(GPFILE *stream)
    // void smc_rewind(GPFILE *stream)
    // int smc_filesize(GPFILE *stream)
    // size_t smc_fwrite(void *ptr,size_t size, size_t nmemb,GPFILE *stream);
    
    gpfile = smc_fopen("dev0:\\gpmm\\filetest.dat","r");
    if (gpfile)  gp_drawString(10,10,18,"smc_fopen :OK     ",0xF800,framebuffer);
    else         gp_drawString(10,10,18,"smc_fopen :ERROR  ",0xF800,framebuffer);

    err = smc_filesize(gpfile);
    sprintf (text,"filetest.dat size: %i ",err);
    gp_drawString(10,20,strlen(text),text,0xF800,framebuffer);

    err = smc_fread(buffer, 12, 1, gpfile);
    if (err == 12 )  gp_drawString(10,30,25,"Loading of 12 byte OK    ",0xF800,framebuffer);
    else gp_drawString(10,30,25,"Loading of 12 byte ERROR   ",0xF800,framebuffer);

    err = smc_ftell(gpfile);
    if (err == 12 )  gp_drawString(10,40,20,"smc_ftell:  OK     ",0xF800,framebuffer);
    else gp_drawString(10,40,20,"smc_ftell:  ERROR   ",0xF800,framebuffer);

    smc_fseek(gpfile, 20,SEEK_SET);
    err = smc_fread(buffer, 10, 1, gpfile);
    gp_drawString(10,60,10,"0123456789",0xF800,framebuffer);
    gp_drawString(10,70,10,buffer,0xF800,framebuffer);

    smc_fclose(gpfile);

    gpfile = smc_fopen("dev0:\\delete.me","w");
    if (gpfile) {
      int size=0;
      gp_drawString(10,80,10,"writing... ",0xF800,framebuffer);      
      char buffer1[20]="1234567890";
      char buffer2[20]="abcdefghij";
      size=smc_fwrite((u8*)buffer1 ,10, 1,gpfile);
      if (size == 10) gp_drawString(10,90,12,"10 bytes ok     ",0xF800,framebuffer);
      size=smc_fwrite((u8*)buffer2 ,10, 1,gpfile);
      smc_fclose(gpfile);
      gp_drawString(10,100,10,"ok         ",0xF800,framebuffer);
    }


  while (1) { if (gp_getButton()&BUTTON_A) gp_Reset();  }

return 0;
}

